#include <stdio.h>
#include <stdlib.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


int main()
{
	elemento *p, *temp;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return 1;

	(*p).valor = 7;
	/*
	Se "p" e' um apontador para uma estrutura do tipo "elemento",
	entao "*p" vai ao endereco "p" e e' a propria estrutura em si.
	Entao posso a seguir (desde que use parentesis) especificar
	a que membro da estrutura quero aceder -- neste caso "valor"
	-- como numa outra estrutura normalissima.
	*/

	p->valor = 8;
	/*
	Este tipo de acesso ("(*p).membro") e' tao comum que existe
	uma abreviatura: o "->".
	*/

	p->proximo = NULL;  /* "nao ha' proximo" */
	primeiro = p;  /* adiciono este como primeiro e unico elemento da lista */


	/* Criar agora o segundo elemento e adiciona'-lo ao final da lista
	   ---------------------------------------------------------------
	*/

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return 1;
	p->valor = 9;
	p->proximo = NULL;

	/*
	Como o adiciono agora? Se fizer
		primeiro = p;
	perco o acesso ao elemento que criei 'a bocado. Neste momento a
	variavel "primeiro" e' o unico sitio onde esta' o endereco dele
	e se perco esse valor, perco o elemento.

	Preciso de o adicionar "'a frente" do elemento que la' esta'
	(em conceito: se o endereco deste elemento e' acima ou abaixo
	do anterior, isso e' irrelevente). Para isso altero o membro
	"proximo" do elemento anteriro para em vez de dizer "NULL"
	que significa "nao ha' elementos a seguir a este", para o
	endereco deste novo elemento
	*/
	primeiro->proximo = p;


	/* "Varrer" a lista e exibir os valores nela contidos
	   --------------------------------------------------
	*/

	for( p = primeiro;  p != NULL;  p = p->proximo )
		printf( "Valor = %d\n", p->valor );


	/* "Varrer" a lista e libertar a memoria por ela ocupada
	   -----------------------------------------------------
	*/

	for( p = primeiro;  p != NULL;  p = temp )
		{
		temp = p->proximo;
		free( p );
		/*
		Tenho de usar este "truque" ("temp") porque nao devo aceder
		a "p->..." ou "*p" depois de ter libertado essa memoria.
		*/
		}
	primeiro = NULL;  /* just in case */

	return 0;
}

