#include <stdio.h>
#include <stdlib.h>


int main()
{
	int *p;
	/*
	"p" = "pointer" ou apontador;
	repara tambem que preciso de repetir o "*" para
	definir outro apontador
	*/

	p = malloc( sizeof(int)*10 );
	/*
	Estou a tentar reservar ("alocar") memoria
	(m-alloc) com bytes suficientes para 10 inteiros
	(dai' o tamanho de um inteiro vezes 10)
	*/

	if( p == NULL )
		{
		/* o malloc() devolve um apontador invalido
		   (definido como "NULL" pelo C) se nao conseguir
		   reservar a memoria
		*/
		printf( "Nao consegui reservar memoria!\n" );
		return 1;
		}

	*p	= 20;
	*(p+1)	= 21;
	*(p+2)	= 22;
	/*
	Como "p" e' um apontador para inteiros, "p+1" e' o endereco do
	"inteiro seguinte", e nao o endereco mais um (cada inteiro ocupa
	4 bytes)
	*/

	p[1] = 31;
	/*
	Tambem posso usar o apontador como se fosse um vector:
	p[0] e' o primeiro inteiro, p[1] o segundo, etc.
	*/

	printf( "Primeiro = %d, segundo = %d, terceiro = %d\n",
		*p, *(p+1), p[2] );
	/* Deve exibir "20,31,22" */

	free( p );
	/*
	Libertar a memoria, se agora ja' nao preciso, para o meu
	programa poder reutilizar essa zona, e/ou nao ocupar tanta
	memoria do computador
	*/

	return 0;
}

