#include <stdio.h>
#include <stdlib.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


void inserir_cabeca( elemento **pcabeca, int numero )
{
	elemento *p;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = numero;
	p->proximo = *pcabeca;
	*pcabeca = p;
}


void inserir_cauda( elemento **pcabeca, int numero )
{
	elemento *p, *ultimo;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = numero;
	p->proximo = NULL;
	if( *pcabeca == NULL )
		*pcabeca = p;
	else
		{
		for( ultimo = *pcabeca;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
		ultimo->proximo = p;
		}
}


void remover_cabeca( elemento **pcabeca )
{
	elemento *temp;

	/* Elimina a cabeca */
	if( *pcabeca != NULL )
		{
		temp = *pcabeca;
		*pcabeca = (*pcabeca)->proximo;
		free( temp );
		}
}


void remover_cauda( elemento **pcabeca )
{
	elemento *p;

	/* Elimina a cauda */
	if( *pcabeca != NULL )
		{
		if( (*pcabeca)->proximo != NULL )
			{
			for( p = *pcabeca;  p->proximo->proximo != NULL;  p = p->proximo );
			free( p->proximo );
			p->proximo = NULL;
			}
		else  /* so' existe 1 elemento na lista! */
			{
			free( *pcabeca );
			*pcabeca = NULL;
			}
		}
}


elemento *pesquisa( elemento *cabeca, int numero )
{
	elemento *p;

	for( p = primeiro; p != NULL; p = p->proximo )
		{
		if( numero == p->valor )
			break;
		}
	return p;
}


int main( void )
{
	int opt, valor;
	elemento *resultado, *p;

	do	{
		printf(	"\n"
			"Escolha uma opcao:\n"
			"1. Inserir 'a cabeca\n"
			"2. Inserir 'a cauda\n"
			"3. Remover a cabeca\n"
			"4. Remover a cauda\n"
			"5. Pesquisar\n"
			"6. Exibir a lista\n"
			"0. Sair\n"
			);
		scanf( "%d", &opt );
		switch( opt )
			{
			case 1:	printf( "Numero a inserir: " );
				scanf( "%d", &valor );
				inserir_cabeca( &primeiro, valor );
				break;
			case 2:	printf( "Numero a inserir: " );
				scanf( "%d", &valor );
				inserir_cauda( &primeiro, valor );
				break;
			case 3:	remover_cabeca( &primeiro );
				break;
			case 4:	remover_cauda( &primeiro );
				break;
			case 5:	printf( "Numero a pesquisar: " );
				scanf( "%d", &valor );
				resultado = pesquisa( primeiro, valor );
				if( resultado == NULL )
					printf( "Nao encontrado\n" );
				else
					printf( "Encontrado no endereco %p", resultado );
				break;
			case 6:	for( p = primeiro;  p != NULL;  p = p->proximo )
					printf( "Valor = %d\n", p->valor );
				break;
			}
		}
		while( opt != 0 );

	return 0;
}
