#include <stdio.h>
#include <stdlib.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


void insere_cabeca( elemento **ppinicio, int valor )
{
	elemento *p;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = valor;
	p->proximo = *ppinicio;
	*ppinicio = p;
}


void insere_cauda( elemento **ppinicio, int valor )
{
	elemento *p, *ultimo;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = valor;
	p->proximo = NULL;
	if( *ppinicio == NULL )
		*ppinicio = p;
	else
		{
		for( ultimo = *ppinicio;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
		ultimo->proximo = p;
		}
}


void remove_cabeca( elemento **ppinicio )
{
	elemento *temp;

	/* Elimina a cabeca */
	if( *ppinicio != NULL )
		{
		temp = *ppinicio;
		*ppinicio = (*ppinicio)->proximo;
		free( temp );
		}
}


void remove_cauda( elemento **ppinicio )
{
	elemento *p;

	/* Elimina a cauda */
	if( *ppinicio != NULL )
		{
		if( (*ppinicio)->proximo != NULL )
			{
			for( p = *ppinicio;  p->proximo->proximo != NULL;  p = p->proximo );
			free( p->proximo );
			p->proximo = NULL;
			}
		else  /* so' existe 1 elemento na lista! */
			{
			free( *ppinicio );
			*ppinicio = NULL;
			}
		}
}


elemento *pesquisar( elemento *inicio, int valor )
{
	elemento *p;

	for( p = inicio; p != NULL; p = p->proximo )
		{
		if( p->valor == valor )
			break;
		}
	return p;
}


int main( void )
{
	int opcao, numero;
	elemento *encontrado, *p;

	do	{
		printf(	"\n"
			"Escolha a sua opcao:\n"
			"1. Inserir 'a cabeca\n"
			"2. Inserir 'a cauda\n"
			"3. Remover a cabeca\n"
			"4. Remover a cauda\n"
			"5. Pesquisar\n"
			"6. Exibir a lista\n"
			"0. Sair\n"
			);
		scanf( "%d", &opcao );
		switch( opcao )
			{
			case 1:	printf( "Introduza o numero: " );
				scanf( "%d", &numero );
				insere_cabeca( &primeiro, numero );
				break;
			case 2:	printf( "Introduza o numero: " );
				scanf( "%d", &numero );
				insere_cauda( &primeiro, numero );
				break;
			case 3:	remove_cabeca( &primeiro );
				break;
			case 4:	remove_cauda( &primeiro );
				break;
			case 5:	printf( "Numero a pesquisar: " );
				scanf( "%d", &numero );
				encontrado = pesquisar( primeiro, numero );
				if( encontrado == NULL )
					printf( "Nao encontrei.\n" );
				else
					printf( "Encontrei no endereco %p\n", encontrado );
				break;
			case 6:	for( p = primeiro;  p != NULL;  p = p->proximo )
					printf( "Valor = %d\n", p->valor );
				break;
			}
		}
		while( opcao != 0 );

	return 0;
}

