#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX  10000000
int v[MAX];


int pesquisa_binaria( int v[], int tam, int val )
{
	int lim_inf, lim_sup, i;

	lim_inf = 0;
	lim_sup = tam-1;

	do	{
		i = (lim_inf + lim_sup) / 2;
		if( val == v[i] )
			return i;
		if( val < v[i] )
			lim_sup = i - 1;
		else
			lim_inf = i + 1;
		}
		while( lim_inf <= lim_sup );

	return -1;
}


int pesquisa_sequencial( int v[], int tam, int val )
{
	int i;

	for( i = 0;  i < tam;  i++ )
		{
		if( val == v[i] )
			return i;
		}
	return -1;
}


int main( void )
{
	int val, val_max, i, ti, tf;

	/* preenche v[] com numeros inteiros aleatorios em ordem crescente */
	srand( (int) time(NULL) );
	val = 0;
	for( i = 0;  i < MAX;  i++ )
		{
		val += rand() % 5;  /* somo ao valor a colocar no vector um "delta" aleatorio entre 0 e 4 */
		v[i] = val;
		}
	val_max = val;

	/* efectua as pesquisas binarias */
	ti = time( NULL );
	for( val = 1;  val <= val_max;  val++ )
		pesquisa_binaria( v, MAX, val );
	tf = time( NULL );
	printf( "A pesquisa binaria demorou %ds.\n", tf-ti+1 );

	/* efectua as pesquisas sequenciais */
	ti = time( NULL );
	for( val = 1;  val <= val_max;  val++ )
		pesquisa_sequencial( v, MAX, val );
	tf = time( NULL );
	printf( "A pesquisa sequencial demorou %ds.\n", tf-ti+1 );

	return 0;
}












