#include <stdio.h>
#include <stdlib.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


void insere_cabeca( elemento **pcabeca, int num )
{
	elemento *p;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = num;
	p->proximo = *pcabeca;
	*pcabeca = p;
}


void insere_cauda( elemento **pcabeca, int num )
{
	elemento *p, *ultimo;

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = num;
	p->proximo = NULL;
	if( *pcabeca == NULL )
		*pcabeca = p;
	else
		{
		for( ultimo = *pcabeca;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
		ultimo->proximo = p;
		}
}


void remove_cabeca( elemento **pcabeca )
{
	elemento *temp;

	/* Elimina a cabeca */
	if( *pcabeca != NULL )
		{
		temp = *pcabeca;
		*pcabeca = (*pcabeca)->proximo;
		free( temp );
		}
}


void remove_cauda( elemento **pcabeca )
{
	elemento *p;

	/* Elimina a cauda */
	if( primeiro != NULL )
		{
		if( primeiro->proximo != NULL )
			{
			for( p = *pcabeca;  p->proximo->proximo != NULL;  p = p->proximo );
			free( p->proximo );
			p->proximo = NULL;
			}
		else  /* so' existe 1 elemento na lista! */
			{
			free( *pcabeca );
			*pcabeca = NULL;
			}
		}
}


elemento *pesquisa( elemento *cabeca, int num )
{
	elemento *p;

	for( p = cabeca; p != NULL; p = p->proximo )
		{
		if( p->valor == num )
			break;
		}
	return p;
}


void escrever( elemento *cabeca )
{
	elemento *p;
	FILE *fp;
	
	fp = fopen( "fich.dat", "wb" );
	if( fp == NULL )
		{
		printf( "Erro ao abrir o ficheiro para escrita.\n" );
		return;
		}
	for( p = cabeca; p != NULL; p = p->proximo )
		fwrite( p, sizeof(elemento), 1, fp );
	fclose( fp );
}


void ler( elemento **pcabeca )
{
	elemento *novo, **pp;
	FILE *fp;
	
	fp = fopen( "fich.dat", "rb" );
	if( fp == NULL )
		{
		printf( "Erro ao abrir o ficheiro -- inexistente?\n" );
		return;
		}
	for( pp = pcabeca; ; pp = &(novo->proximo) )
		{
		novo = malloc( sizeof(elemento) );
		if( novo == NULL			||
		    fread(novo, sizeof(elemento), 1, fp) != 1 )
			{
			*pp = NULL;
			if( novo != NULL )
				free( novo );
			break;
			}
		*pp = novo;
		}
	fclose( fp );
}

				
int main( void )
{
	int opcao, numero;
	elemento *encontrado, *p;

	do	{
		printf(	"\n"
			"Escolha a opcao\n"
			"1. Inserir 'a cabeca\n"
			"2. Inserir 'a cauda\n"
			"3. Remover a cabeca\n"
			"4. Remover a cauda\n"
			"5. Pesquisar\n"
			"6. Exibir a lista\n"
			"7. Ler a lista de disco ('fich.dat')\n"
			"8. Escrever a lista para o disco ('fich.dat')\n"
			"0. Sair\n"
			);
		scanf( "%d", &opcao );
		switch( opcao )
			{
			case 1:	printf( "Introduza o numero:" );
				scanf( "%d", &numero );
				insere_cabeca( &primeiro, numero );
				break;
			case 2:	printf( "Introduza o numero:" );
				scanf( "%d", &numero );
				insere_cauda( &primeiro, numero );
				break;
			case 3:	remove_cabeca( &primeiro );
				break;
			case 4:	remove_cauda( &primeiro );
				break;
			case 5:	printf( "Introduza o numero a pesquisar:" );
				scanf( "%d", &numero );
				encontrado = pesquisa( primeiro, numero );
				if( encontrado == NULL )
					printf( "Nao encontrei\n" );
				else
					printf( "Encontrado no endereco %p", encontrado );
				break;
			case 6:	for( p = primeiro;  p != NULL;  p = p->proximo )
					printf( "Valor = %d\n", p->valor );
				break;
			case 7:	ler( &primeiro );
				break;
			case 8:	escrever( primeiro );
				break;
			}
		}
		while( opcao != 0 );

	return 0;
}
